//  The Master Cow's Game Menu
//  by Jason Quattrini
//  v0.99k2
//  01/10/01
//
//  This program is a menu, intended for running games, for an MS-DOS based
//    computer.  It can be used with almost any DOS-based program if you
//    so desire.

#ifndef _GAMEMENU.H_
#define _GAMEMENU.H_

#include <stdio.h>
#include <stdlib.h>

//  Screen I/O
#include <conio.h>

//  Check for specific character types
#include <ctype.h>

//  String stuff
#include <string.h>

// for keyboard input stuff
#include <bios.h>

// for random functions
#include <time.h>

//  List stuff
#include <iomanip.h>
#include <fstream.h>

#define YES 1
#define NO 0


//  Current menu version, date and approximate time of last modification
#define VERSION "0.99k2"
#define DATE "01/10/01"
#define TIME "9:45 am"

//  Length of each component for the game data
#define NAMELENGTH 41
#define DIRLENGTH 62
#define EXECLENGTH 13
#define OPTIONLENGTH 76

#define MAXLENGTH 120

#define LFNLENGTH 256

//  Position and size definitions for the various menu windows
#define SELMENUTOP 3
#define SELMENUBOT 19
#define SELMENULEFT 3
#define SELMENURIGHT SELMENULEFT+NAMELENGTH-1

#define PATHWINLEFT 3
//(80-DIRLENGTH)/2
#define PATHWINRIGHT PATHWINLEFT+DIRLENGTH-1
#define PWINPOS 22

#define EXECWINLEFT PATHWINRIGHT+2
//(80-(EXECLENGTH+OPTIONLENGTH+2))/2+1
#define EXECWINRIGHT EXECWINLEFT+EXECLENGTH-1
#define EXECWINPOS PWINPOS
//PWINPOS+2

#define OPTWINLEFT 3
//EXECWINRIGHT+2
#define OPTWINRIGHT OPTWINLEFT+OPTIONLENGTH-1
#define OPTWINPOS PWINPOS + 2
//EXECWINPOS

//  Quit messages.  Absolutly necessary.
#define MESSAGE1 "Why don't you go to bed now?"

#define MESSAGE2 "If it takes a chicken and a half a day and a half to \
lay an egg and a half, how long does it take a grasshopper with a wooden \
leg to kick all of the seeds out  of a dill pickle?"

#define MESSAGE3 "Thank you, drive through."
#define MESSAGE4 "... *sigh*"
#define MESSAGE5 "What a smophead you are!"
#define MESSAGE6 "Sometimes I just feel like licking Danny."
#define MESSAGE7 "Gee geeeee!!!"
#define MESSAGE8 "I am a werecow!  MMMMMooo-OOOOOOOOOOOOOOOOOOOOO!!!!"
#define MESSAGE9 "Number 9... number 9... number 9..."

//  Swiped from Borland Tcalc example
//  Keyboard character definitions
#define BS 8
#define CR 13
#define ESC 27
#define HOMEKEY 327
#define ENDKEY 335
#define UPKEY 328
#define DOWNKEY 336
#define PGUPKEY 329
#define PGDNKEY 337
#define LEFTKEY 331
#define INSKEY 338
#define RIGHTKEY 333
#define DELKEY 339

#define F1 315
#define F2 316
#define F3 317
#define F4 318
#define F5 319
#define F6 320
#define F7 321
#define F8 322
#define F9 323
#define F10 324

//  End Swipe

#define NUM8 56
#define NUM2 50

enum Boolean{ FALSE, TRUE };

//  Portion of a game's data to consider
enum gamepiece {NAME, DIRNAME, EXECNAME, EXECOPTS};


//  Class to store the color scheme in
class colorset
{
  public:
    COLORS mainbg,  //  Main window background
           mainfg,  //    and text colors
           namebg,  //  List window background
           namefg,  //    and text colors
           winbg,   //  Game directory, exececutable name, and option window
           winfg,   //    background and text colors
           barbg,   //  Current game highlight bar
           barfg;   //    and text colors
};

/*
//  Game info
class game
{
  public:
  char name[NAMELENGTH + 1],           //  The name of the game
       directory[LFNLENGTH + 1],       //  The directory in which it resides
                                       //    (path to the game)
       exec_name[LFNLENGTH + 1],       //  What to run to make the game go
       exec_options[LFNLENGTH +1];     //  Any options to feed to the game
                                       //    when run
};


//  This is the base class for the list
class List
{
   public:
      List();
      game Data;
      class List *Next, *Head, *topPtr, *botPtr, *Cur, *Prev, *Ptr;
      void Traverse(int);      //  Going through the list and printing
                                //    out the contents
      void Sort(void);          //  Sorting (evil!) the linked list
};
*/

class node
{
  friend class List2;
  node* Next;
  node* Prev;
};


//  This is the base class for the list
class List2
{
   node* Head;
//   node* Prev;
   node* Cur;
   public:
      List2()
        {
         /* Prev =*/ Head = Cur = NULL;
        }
      void Insert(node* p);
      node* Remove();
      node* First()
        {
          /*Prev = NULL;*/
          Cur = Head;
          return Cur;
        }
      node* Next();
      node* Current()
        {
          return Cur;
        }
      node* Previous();
      Boolean Empty()
        {
          return Boolean(Head == NULL);
        }


};



/*
//  The constructor for the list.
List :: List()
{
   Prev = NULL;
   Head = NULL;
   Cur = Head;
}
*/

//  Travel through the now populated list and print out the values that
//    are the game items in the said linked list

/*void List :: Traverse(int timethrough)
{
   int hank;

   if (Head)
   {
     if (timethrough)
     Ptr = topPtr;
     else
       Ptr = Head;
     hank = 0;
     while ((Ptr != NULL) && (hank < SELMENULEN-1))
     {
        if (hank != SELMENULEN-2)
          cprintf("%s\n\r", Ptr->Data.name);
        else
          cprintf("%s", Ptr->Data.name);
        if ((hank == SELMENULEN-2) || (Ptr->Next == NULL))
          botPtr = Ptr;
        Ptr = Ptr->Next;
        hank = hank + 1;
     }
   }
   else
     cprintf ("(No games in list)");
}
*/

//  Sort the list
//  I think this is similar (identical to?) the bubble sort, but I can
//    never remember what sort is what, or how half of them work...

/*
void List :: Sort(void)
{
   game Tmp;
   int DidItChange = YES;
   int i;
   char firstname[NAMELENGTH + 1], secondname[NAMELENGTH +1 ];

   while (DidItChange == YES)
   {
      Ptr = Head;                   //  Goes through and swaps adjacent
      DidItChange = NO;             //    data if the first is larger than
      while (Ptr->Next != NULL)     //    the second.  Does this until no
      {                             //    data is swapped.
         strcpy(firstname, Ptr->Data.name);
         strcpy(secondname, Ptr->Next->Data.name);
         for (i=0; i < NAMELENGTH; i++)
         {
           firstname[i] = toupper(firstname[i]);
           secondname[i] = toupper(secondname[i]);
         }
         if (strcmp(firstname,secondname) > 0)
         {
            Tmp = Ptr->Data;
            Ptr->Data = Ptr->Next->Data;
            Ptr->Next->Data = Tmp;
            DidItChange = YES;
         }
         Ptr = Ptr->Next;
      }
   }
}

*/

//  Assorted graphics stuff for window drawing
void big_window(class colorset &);
void name_window(class colorset &);
void highlight2(int, class List &, class colorset &);
void big_window(class colorset &);
void exec_window(class colorset &);
void path_window(class colorset &);
void opt_window(class colorset &);

void quit_window(void);

void submenuwin(void);
void lightbutton(int &);

void add_window(void);

void deletewin(char *);
void lightdelbutton(int &);

//  Functions to get game data from the config file
void addgame(class List &, FILE &);
void getdir2(class game &, FILE &);
void getname2(class game &, FILE &);
void getexec2(class game &, FILE &);
void getoptions2(class game &, FILE &);
int nukeblank(FILE &);

//  Write the config file
void writecfg(class game &, FILE &);

//  Write the batch file to run the current game
void rungame(class game &);

//  List related functions
//  Insert and remove a game in and from the list
//  Find an item
void insertgame(class List &, int &, class colorset &);
void removegame(class List &, int &);
int finditem(class List &, int &, int &);

//  Read a key from the keyboard
int getkey(void);

//  Functions to get/edit game data from the user
void getitem(char *, enum gamepiece &, int);
void editgame(class game &a_game, class colorset &);

//  Parse them command line arguments
void parseargs(char **, class colorset &, int &);

//  Copy an item
void copygame(class List &);


////////////////*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*///////////////


void addgame2(class gamelist2&, FILE &);
void getdir3(char*, FILE &);
void getname3(char*, FILE &);
void getexec3(char*, FILE &);
void getoptions3(char*, FILE &);
void traverse(class gamelist2 &, class barpos &, int);
void sort(class gamelist2 &, class colorset &);
void highlight3(int, class gamelist2 &, class colorset &);
void rungame2(class gamelist2 &);
void removegame2(class gamelist2 &, int &, class barpos &, int);
void insertgame2(class gamelist2 &, int &, class colorset &);
void copygame2(class gamelist2 &, class barpos &);
void editgame2(class gamelist2 &, class colorset &);
int finditem2(class gamelist2 &, int &, int &, class barpos &, int &);
void writecfg2(class gamelist2 &, FILE &);

void refresh (class colorset &, class gamelist2 &, class barpos &, int &);


#endif
