//  The Master Cow's Game Menu
//  by Jason Quattrini
//  v0.99k2
//  01/10/01
//
//  This program is a menu, intended for running games, for an MS-DOS based
//    computer.  It can be used with almost any DOS-based program if you
//    so desire.

#include "gameme_u.h"
#include "menulist.cpp"

int main(int argc, char* argv[])
{
   gamelist2 games;           //  The game list
   FILE *in, *out;            //  File pointers for the config file
   int numgames;              //  Number of games in the list
   int count2, bob, loop;     //  Loop variables
   char plop;                 //  Character read in from the cfg file
   int monkey = SELMENUTOP;   //  Location of the higlight bar on the screen
   int keypushed;             //  The numerical value for the key pushed
   int choice;                //  Current choice in submenus
   char command[MAXLENGTH+8]; //  Stores DOS command names
   colorset colors;           //  Colors for use by the menu
   barpos menupos;
   int i;


   //  Set up initial colors
   colors.mainbg = BLUE;       //  Main window background
   colors.mainfg = WHITE;      //  Main window text
   colors.namebg = BLACK;      //  List window background
   colors.namefg = LIGHTGREEN; //  List window text
   colors.winbg = BLACK;       //  Directory, option, and executable name bg
   colors.winfg = WHITE;       //  Text for above
   colors.barbg = RED;         //  Highlight bar color
   colors.barfg = WHITE;       //  Highlight bar text

   // Figure out where the menu is being run from
   sprintf(command, "cd > basedir.jmq");
   system(command);

   // Make the cursor invisible
   _setcursortype(_NOCURSOR);


   // See if there's a config file.  If not, initialize stuff.  If so,
   //   rock on!
   if ((in = fopen("gmenu.cfg", "rb"))
       == NULL)
   {
     big_window(colors);
     path_window(colors);
     clrscr();
     exec_window(colors);
     clrscr();
     opt_window(colors);
     clrscr();

     numgames = 0;

     name_window(colors);
     clrscr();

     menupos.dist = 0;
     menupos.top = 0;
     menupos.bottom = 0;

     traverse(games, menupos, 0);
   }
   else
   {
     clrscr();

     numgames = 0;
     bob = 0;

     // Read in the color scheme
     if (!feof(in))
     {
       fscanf(in, "%d", &colors.mainbg);
       fscanf(in, "%d", &colors.mainfg);
       fscanf(in, "%d", &colors.namebg);
       fscanf(in, "%d", &colors.namefg);
       fscanf(in, "%d", &colors.winbg);
       fscanf(in, "%d", &colors.winfg);
       fscanf(in, "%d", &colors.barbg);
       fscanf(in, "%d", &colors.barfg);
     }

     // Read in them games
     while (!feof(in))
     {
       if (!bob)
         plop = fgetc(in);
       else
       {
         plop = '';
         bob = 0;
       }
       if (plop == '')
       {
         addgame2(games, *in);
         numgames = numgames + 1;
       }
       else
       {
         bob = nukeblank(*in);
       }
     }
     fclose(in);

     // Figure out the command line stuff
     parseargs(argv, colors, argc);

     big_window(colors);

     if (!games.Empty())
     {
       sort(games, colors);
     }
     path_window(colors);
     clrscr();
     exec_window(colors);
     clrscr();
     opt_window(colors);
     clrscr();

     name_window(colors);
     clrscr();

     menupos.dist = 0;
     menupos.top = 0;
//     sort(games);
     if (numgames > (SELMENUBOT - SELMENUTOP + 1))
       menupos.bottom = SELMENUBOT - SELMENUTOP + 1;
     else if (numgames > 0)
       menupos.bottom = numgames - 1;
     else menupos.bottom = 0;

     traverse(games, menupos, 0);
//     if (!games.Empty())
       highlight3(monkey, games, colors);
   }


   //  Get a key and process it
   while ((keypushed = getkey()) != ESC)
   {

     // DOWN ARROW
     if ((keypushed == DOWNKEY) && (games.Next() != NULL)
           && !( games.Empty() ))
     {
       menupos.dist += 1;
       if ((monkey >= SELMENUTOP) && (monkey <= SELMENUBOT))
       {
         monkey = monkey + 1;
       }
       else if (monkey == SELMENUBOT+1)
       {
         menupos.top += 1;
         menupos.bottom += 1;
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         name_window(colors);
         clrscr();
         traverse(games, menupos, 1);
       }
       highlight3(monkey, games, colors);
     }

     // PAGEDOWN
     if ((keypushed == PGDNKEY) && (games.Next() != NULL)
           && !( games.Empty() ))
     {
       games.Previous();
       if ((monkey >= SELMENUTOP) && (monkey <= SELMENUBOT) )
       {
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         name_window(colors);
         clrscr();
         traverse(games, menupos, 1);
         while (menupos.dist < menupos.bottom)
         {
           if (monkey <= SELMENUBOT)
           {
             games.Next();
             menupos.dist += 1;
             monkey += 1;
           }
         }
       }
       else if (monkey == SELMENUBOT+1)
       {
         bob = 0;
         while ( (menupos.bottom < numgames-1) &&
                 ( bob <= menupos.bottom-menupos.top ) )
         {
           menupos.bottom += 1;
           menupos.top += 1;
           menupos.dist += 1;
           bob += 1;
         }
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         name_window(colors);
         clrscr();
         traverse(games, menupos, 1);
       }
       highlight3(monkey, games, colors);
     }

     // END
     else
     if ((keypushed == ENDKEY) && (games.Next() != NULL)
           && !(games.Empty()))
     {
       games.Previous();
       while ((games.Next() != NULL) && (menupos.dist < numgames))
       {
         if (monkey <= SELMENUBOT)
         {
           monkey = monkey + 1;
           menupos.dist += 1;
         }
         else
         if (monkey == SELMENUBOT+1)
         {
           menupos.top += 1;
           menupos.bottom += 1;
           menupos.dist += 1;
         }
       }
       games.First();
       for (i = 0; i < menupos.top; i++)
         games.Next();

       name_window(colors);
       clrscr();
       traverse(games, menupos, 1);
       highlight3(monkey, games, colors);
     }

     // UP ARROW
     else
     if ((keypushed == UPKEY) && (games.Previous() != NULL)
          && !( games.Empty() ))
     {
       menupos.dist -= 1;
       if ((monkey > SELMENUTOP) && (monkey <= SELMENUBOT+1))
       {
         monkey = monkey - 1;
       }
       else if (monkey == SELMENUTOP)
       {
         menupos.top -= 1;
         menupos.bottom -= 1;
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         name_window(colors);
         clrscr();
         traverse(games, menupos, 1);
       }
       highlight3(monkey, games, colors);
     }

     // HOME
     else
     if ((keypushed == HOMEKEY) && (games.Previous() != NULL)
           && !(games.Empty()))
     {
       games.Next();
       while (games.Previous() != NULL)
       {
         if (monkey > SELMENUTOP)
           monkey = monkey - 1;
         else
         if (monkey == SELMENUTOP)
         {
           menupos.top -= 1;
           menupos.bottom -= 1;
         }
       }
       menupos.dist = menupos.top;

       name_window(colors);
       clrscr();
       traverse(games, menupos, 1);
       highlight3(monkey, games, colors);
     }

     // PAGEUP
     else
     if ((keypushed == PGUPKEY) && (games.Previous() != NULL)
           && !( games.Empty() ))
     {
       games.Next();
       if ((monkey > SELMENUTOP) && (monkey <= SELMENUBOT+1) )
       {
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         name_window(colors);
         clrscr();
         traverse(games, menupos, 1);
         while (menupos.dist > menupos.top)
         {
           if (monkey > SELMENUTOP)
           {
             games.Previous();
             monkey -= 1;
             menupos.dist -= 1;
           }
         }
       }
       else if (monkey == SELMENUTOP)
       {
         bob = 0;
         while ( (menupos.top > 0) &&
                 ( bob <= menupos.bottom-menupos.top ) )
         {
           menupos.bottom -= 1;
           menupos.top -= 1;
           menupos.dist -= 1;
           bob += 1;
         }
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         name_window(colors);
         clrscr();
         traverse(games, menupos, 1);
       }
       highlight3(monkey, games, colors);
     }

     // ENTER
     else
     if (keypushed == CR)
     {
       submenuwin();
       choice = 0;
       lightbutton(choice);
       keypushed = 'X';
       while (keypushed != ESC)
       {
         if ( ((keypushed == UPKEY) || (keypushed == LEFTKEY)) &&
               (choice > 0) )
         {
           choice = choice - 1;
           submenuwin();
           lightbutton(choice);
           keypushed = getkey();
         }
         else
         if ( ((keypushed == DOWNKEY) || (keypushed == RIGHTKEY)) &&
               (choice < 3) )
         {
           choice = choice + 1;
           submenuwin();
           lightbutton(choice);
           keypushed = getkey();
         }
         else
         if (keypushed == CR)
         {
           switch (choice)
           {
             // RUN
             case 0:  if (!games.Empty())
                      {
                        rungame2(games);
                        out = fopen("gmenu.cfg", "wt");
                        fprintf(out, "%d ", colors.mainbg);
                        fprintf(out, "%d ", colors.mainfg);
                        fprintf(out, "%d ", colors.namebg);
                        fprintf(out, "%d ", colors.namefg);
                        fprintf(out, "%d ", colors.winbg);
                        fprintf(out, "%d ", colors.winfg);
                        fprintf(out, "%d ", colors.barbg);
                        fprintf(out, "%d\n", colors.barfg);
                        games.First();
                        if (!games.Empty())
                        {
                          writecfg2(games, *out);
                          while (games.Next() != NULL)
                            writecfg2(games, *out);
                        }
                        fclose(out);
                        remove("basedir.jmq");
                        _setcursortype(_NORMALCURSOR);
                        exit(0);
                      }
                      keypushed = ESC;
                      break;

             // EDIT
             case 1:  if (!games.Empty())
                      {
                          _setcursortype(_NORMALCURSOR);
                          editgame2(games, colors);
                          _setcursortype(_NOCURSOR);
                          sort(games, colors);
                      }
                      else
                      {
                        window(21, 11, 60, 13);
                        textbackground(LIGHTGRAY);
                        textcolor(RED);
                        clrscr();
                        cprintf("\n      %cYou must add a game first!", 173);
                          //  173 is the upside down exclamation mark
                        getkey();
                      }
                      keypushed = ESC;
                      break;

             // CANCEL
             case 2:  keypushed = ESC;
                      break;

             // ADD NEW
             case 3:  _setcursortype(_NORMALCURSOR);
                      insertgame2(games, monkey, colors);
                      _setcursortype(_NOCURSOR);
                      numgames = numgames + 1;
                      sort(games, colors);
                      if ((menupos.bottom < numgames - 1) &&
                          (menupos.top == 0 ))
                      {
                        if (menupos.bottom <= SELMENUBOT-SELMENUTOP)
                        menupos.bottom += 1;
                      }
                      keypushed = ESC;
                      break;
           }
         }
         else
           keypushed = getkey();
       }
       window(1,1,80,25);
       clrscr();
       big_window(colors);
       path_window(colors);
       clrscr();
       exec_window(colors);
       clrscr();
       opt_window(colors);
       clrscr();
       name_window(colors);
       clrscr();
       if (!games.Empty())
       {
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         traverse(games, menupos, 1);
         highlight3(monkey, games, colors);
       }
       else
         cprintf("(Still nothing in the list)");
     }

     // DELETE
     else
     if ( (keypushed == DELKEY) && (!games.Empty()))
     {
       deletewin(games.Current()->getname());
       choice = 1;
       lightdelbutton(choice);
       keypushed = 'X';
       while (keypushed != ESC)
       {
         if ( ((keypushed == UPKEY) || (keypushed == LEFTKEY)) &&
               (choice > 0) )
         {
           choice = choice - 1;
           deletewin(games.Current()->getname());
           lightdelbutton(choice);
           keypushed = getkey();
         }
         else
         if ( ((keypushed == DOWNKEY) || (keypushed == RIGHTKEY)) &&
               (choice < 1) )
         {
           choice = choice + 1;
           deletewin(games.Current()->getname());
           lightdelbutton(choice);
           keypushed = getkey();
         }
         else
         if (keypushed == CR)
         {
           switch (choice)
           {
             // Yes, delete it
             case 0:
               removegame2(games, monkey, menupos, numgames);
               numgames = numgames - 1;
               name_window(colors);
               games.First();
                 for (i = 0; i < menupos.top; i++)
                   games.Next();
               traverse(games, menupos, 1);
               if (!games.Empty())
               {
                 highlight3(monkey, games, colors);
               }
/*               else
               {
                 path_window(colors);
                 clrscr();
                 exec_window(colors);
                 clrscr();
                 opt_window(colors);
                 clrscr();
               }
*/               keypushed = ESC;
               break;

             // No!  I goofed!
             case 1:
               keypushed = ESC;
               break;
           }
         }
         else
           keypushed = getkey();
       }
       big_window(colors);
       path_window(colors);
       clrscr();
       exec_window(colors);
       clrscr();
       opt_window(colors);
       clrscr();
       name_window(colors);
       clrscr();
       if (!games.Empty())
       {
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         traverse(games, menupos, 1);
         highlight3(monkey, games, colors);
       }
       else cprintf("(Now you done it!  All gone!)");
     } // end of delete key portion


     // INSERT (copies an entry)
     else
     if ( (keypushed == INSKEY) && (!games.Empty()) )
     {
       copygame2(games, menupos);
       numgames += 1;

       path_window(colors);
       clrscr();
       exec_window(colors);
       clrscr();
       opt_window(colors);
       clrscr();
       name_window(colors);
       clrscr();
       if (!games.Empty())
       {
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         traverse(games, menupos, 1);
         highlight3(monkey, games, colors);
//         if ((menupos.bottom < numgames - 1) && (menupos.top == 0 ))
//         {
//           if (menupos.bottom <= SELMENUBOT-SELMENUTOP)
//             menupos.bottom += 1;
//         }
       }
     }

//  Hopefully allow changing of colors while in the menu

     // Function Keys
     else
     if (keypushed == F1)
     {
       colors.mainbg += 1;
       if (colors.mainbg >= 16)
         colors.mainbg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F2)
     {
       colors.mainfg += 1;
       if (colors.mainfg >= 16)
         colors.mainfg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F3)
     {
       colors.namebg += 1;
       if (colors.namebg >= 16)
         colors.namebg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F4)
     {
       colors.namefg += 1;
       if (colors.namefg >= 16)
         colors.namefg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F5)
     {
       colors.winbg += 1;
       if (colors.winbg >= 16)
         colors.winbg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F6)
     {
       colors.winfg += 1;
       if (colors.winfg >= 16)
         colors.winfg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F7)
     {
       colors.barbg += 1;
       if (colors.barbg >= 16)
         colors.barbg = 0;
       refresh (colors, games, menupos, monkey);
     }
     else
     if (keypushed == F8)
     {
       colors.barfg += 1;
       if (colors.barfg >= 16)
         colors.barfg = 0;
       refresh (colors, games, menupos, monkey);
     }


     // Any other key.  If it's a printable character, search for an entry
     //   with that character as the starting character
     else
     if ( (isprint(keypushed)) && (!games.Empty()))
     {
       if (finditem2(games, keypushed, monkey, menupos, numgames))
       {
         name_window(colors);
         clrscr();
//         gamelist.Traverse(1);
//         highlight2(monkey+1, gamelist, colors);
         games.First();
         for (i = 0; i < menupos.top; i++)
           games.Next();
         traverse(games, menupos, 1);
         highlight3(monkey, games, colors);
       }
     }


   }
   quit_window();

   out = fopen("gmenu.cfg", "wt");

   fprintf(out, "%d ", colors.mainbg);
   fprintf(out, "%d ", colors.mainfg);
   fprintf(out, "%d ", colors.namebg);
   fprintf(out, "%d ", colors.namefg);
   fprintf(out, "%d ", colors.winbg);
   fprintf(out, "%d ", colors.winfg);
   fprintf(out, "%d ", colors.barbg);
   fprintf(out, "%d\n", colors.barfg);

   games.First();
   if (!games.Empty())
   {
     writecfg2(games, *out);
     while (games.Next() != NULL)
       writecfg2(games, *out);
   }
   fclose(out);
   remove("basedir.jmq");
   remove("callme.bat");

   _setcursortype(_NORMALCURSOR);
   exit(1);
   return(0);
}

//**************************************************************************
//  Set up the name list window
//**************************************************************************

void name_window(colorset &colors)
{
   textbackground(colors.namebg);
   textcolor(colors.namefg);
   window(SELMENULEFT, 3, SELMENURIGHT, SELMENUBOT+1);
   clrscr();
}


//**************************************************************************
//  Set up the game's path window
//**************************************************************************

void path_window(colorset &colors)
{
   textbackground(colors.winbg);
   textcolor(colors.winfg);
   window(PATHWINLEFT, PWINPOS, PATHWINRIGHT, PWINPOS);
   clrscr();
}


//**************************************************************************
//  Set up the game's executable name window
//**************************************************************************

void exec_window(colorset &colors)
{
   textbackground(colors.winbg);
   textcolor(colors.winfg);
   window(EXECWINLEFT, EXECWINPOS, EXECWINRIGHT, EXECWINPOS);
   clrscr();
}


//**************************************************************************
//  Set up the option window
//**************************************************************************

void opt_window(colorset &colors)
{
   textbackground(colors.winbg);
   textcolor(colors.winfg);
   window(OPTWINLEFT, OPTWINPOS, OPTWINRIGHT, OPTWINPOS);
   clrscr();
}


//**************************************************************************
//  Set up and draw the main window, including the title bar and instructions
//**************************************************************************

void big_window(colorset &colors)
{
   int count;        //  Loop variable
   int num;          //  Number used to shift text in the title bar
   char *title="The Master Cow's Game Menu";    //  The name of the menu prog

   num = 53 - strlen(title);
   textbackground(colors.mainbg);
   textcolor(BLACK);
   window(1,1,80,25);
   clrscr();
   window(SELMENURIGHT+3, 3, 78, SELMENUBOT+1);
   textbackground(LIGHTGRAY);
   cprintf("\n\n %c ", 24); // up arrow character
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(", ");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" %c ",25);     // down arrow character
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(", ");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" PgUp ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(", ");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" PgDn ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(", ");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" Home ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(", ");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" End ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(" to Scroll.\n\n\r");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" %c%cEnter ", 27, 217);
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(" to Run or Edit the\n\r selected item.\n\n\r");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" %c%cEnter ", 27, 217);
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(", then select ");
   textbackground(BLUE);
   textcolor(WHITE);
   cprintf(" ADD NEW \n\r");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(" to Add a game.\n\n\r");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" Insert ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(" to Copy a game.\n\n\n\r");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" Delete ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(" to Remove a game.\n\n\n\r");
   textcolor(BLACK);
   textbackground(LIGHTGRAY);
   cprintf(" Esc ");
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   cprintf(" to Quit.\n\r");


   textbackground(LIGHTGRAY);
   textcolor(WHITE);
   window(1,1,80,1);
   clrscr();
   cprintf(" %s v", title);
   textcolor(BLACK);
   for (count = 3; count < strlen(title)-8; count +=2)
   {
     gotoxy(count,1);
     cprintf("%c", title[count-2]);
   }
   gotoxy(strlen(title)+4, 1);
   textcolor(RED);
   cprintf("%s", VERSION);
   textcolor(LIGHTBLUE);
   for (count = 0; count < num; count ++)
     cprintf(" ");
   cprintf("%8s \~%5s", DATE, TIME);
}

void traverse(gamelist2 &glist, barpos &locale, int timethrough)
{
   int hank;
   game2* pos;
   int i;

   if ( !glist.Empty() )
   {
     if (timethrough)
       pos = glist.Current();
     else
       pos = glist.First();
     hank = 0;
     while ((pos != NULL) && (hank < SELMENUBOT-1))
     {
        if (hank != SELMENUBOT-2)
          cprintf("%s\n\r", pos->getname());
        else
          cprintf("%s", pos->getname());
        pos = glist.Next();
        hank = hank + 1;
     }
     glist.First();
     for (i = 0; i < locale.dist; i++)
       glist.Next();
   }
   else
     cprintf ("(Nothing in the list!)");
}


void sort(gamelist2 &glist, colorset &colors)
{
   game2 *tmp, *tmp2, *tmp3/*, *curgame*/;
   int DidItChange = YES;
   int i;
   char firstname[NAMELENGTH + 1], secondname[NAMELENGTH +1 ];
   char currentname[NAMELENGTH+1];

   window(34,23,46,23);
   textbackground(BLACK);
   textcolor(WHITE);
   clrscr();
   cprintf("Sorting...");

   while (DidItChange == YES)
   {
      tmp = glist.First();          //  Goes through and swaps adjacent

      DidItChange = NO;             //    data if the first is larger than
      while ((tmp2 = glist.Next()) != NULL)     //    the second.  Does this until no
      {                             //    data is swapped.
         tmp = glist.Previous();
         strcpy(firstname, tmp->getname());
         strcpy(secondname, tmp2->getname());
         for (i=0; i < NAMELENGTH; i++)
         {
           firstname[i] = toupper(firstname[i]);
           secondname[i] = toupper(secondname[i]);
         }
         if (strcmp(firstname,secondname) > 0)
         {
            tmp3 = tmp;
            glist.Remove();
            glist.Insert(new game2(tmp3->getname(), tmp3->getdir(),
                                   tmp3->getexec(), tmp3->getopts() ));

            DidItChange = YES;
            glist.Next();
         }
         else
           glist.Next();
      }
   }
   textbackground(colors.mainbg);
   textcolor(colors.mainfg);
   clrscr();
}



//**************************************************************************
//  Get rid of garbage that might be lying between games for some reason
//**************************************************************************

int nukeblank(FILE &infile)
{
   char plop;       //  Character read in from the config file.  Shouldn't
                    //    be there

   plop = fgetc(&infile);
   while (!feof(&infile))
   {
     if (plop == '')
       return(1);
     else
     {
       plop = fgetc(&infile);
     }
   }
   return(0);
}

//**************************************************************************
//  Adds a game to the list from the configuration file
//**************************************************************************

void addgame2(gamelist2 &games, FILE &infile)
{
   char newname[NAMELENGTH + 1];
   char newdir[LFNLENGTH + 1];
   char newexec[LFNLENGTH + 1];
   char newopts[LFNLENGTH + 1];

   getname3(newname, infile);
   getdir3(newdir, infile);
   getexec3(newexec, infile);
   getoptions3(newopts, infile);

   games.Insert(new game2(newname, newdir, newexec, newopts));
}

//**************************************************************************
//  Gets the game name from the cfg file
//**************************************************************************

void getname3(char name[NAMELENGTH + 1], FILE &infile)
{
   char plop;                      //  Character read from config file
   int count = 0;                  //  Name length counter

   count = 0;
   plop = fgetc(&infile);
   name[count] = NULL;
   while ((plop != '\r') && (count < NAMELENGTH))
   {
     name[count] = plop;
     name[count + 1] = NULL;
     plop = fgetc(&infile);
     count = count + 1;
   }
}


//**************************************************************************
//  Gets the game directory from the config file
//**************************************************************************

void getdir3(char dirname[LFNLENGTH + 1], FILE &infile)
{
   char plop;                       //  Character read in from config file
   int count = 0;                   //  Dir. name length counter
   char trash;                      //  Crap (gets rid of \n's)

   trash = fgetc(&infile);

   count = 0;
   plop = fgetc(&infile);
   dirname[count] = NULL;
   while ((plop != '\r') && (count < LFNLENGTH))
   {
     dirname[count] = plop;
     dirname[count+1] = NULL;
     plop = fgetc(&infile);
     count = count + 1;
   }
}


//**************************************************************************
//  Gets the executable name from the config file
//**************************************************************************

void getexec3(char execname[LFNLENGTH + 1], FILE &infile)
{
   char plop;                         //  Char. read from cfg file
   int count = 0;                     //  Yes.  Sick of typing it.
   char trash;                        //  Same as previous function

   trash = fgetc(&infile);

   count = 0;
   plop = fgetc(&infile);
   execname[count] = NULL;
   while ((plop != '\r') && (count < LFNLENGTH))
   {
     execname[count] = plop;
     execname[count +1] = NULL;
     plop = fgetc(&infile);
     count = count + 1;
   }
}


//**************************************************************************
//  Gets the game options from the config file
//**************************************************************************

void getoptions3(char execopts[LFNLENGTH + 1], FILE &infile)
{
   char plop;                          //  Yet again
   int count = 0;                      //  Grrr
   char trash;                         //  No.

   trash = fgetc(&infile);
   count = 0;
   plop = fgetc(&infile);
   execopts[count] = NULL;
   while ((plop != '') && (count < LFNLENGTH))
   {
     execopts[count] = plop;
     execopts[count + 1] = NULL;
     plop = fgetc(&infile);
     count = count + 1;
   }
}

//**************************************************************************
//  Highlights a game in the list
//**************************************************************************

void highlight3(int line, gamelist2 &games, colorset &colors)
{
   int len;
   int curchar;
   game2* curgame;

   if (!games.Empty())
   {
     if ((line > SELMENUTOP) && (games.Previous() != NULL))
     {
       curgame = games.Current();
       textbackground(colors.namebg);
       textcolor(colors.namefg);
       window(SELMENULEFT,line-1,SELMENURIGHT,line-1);
       clrscr();
       cprintf("%s", curgame->getname());
       curgame = games.Next();
     }
     if ((line < SELMENUBOT+1) && (games.Next() != NULL))
     {
       curgame = games.Current();
       textbackground(colors.namebg);
       textcolor(colors.namefg);
       window(SELMENULEFT,line+1,SELMENURIGHT,line+1);
       clrscr();
       cprintf("%s", curgame->getname());
       curgame = games.Previous();
     }
     curgame = games.Current();
     textbackground(colors.barbg);
     textcolor(colors.barfg);
     window(SELMENULEFT,line,SELMENURIGHT,line);
     clrscr();
     cprintf("%s", curgame->getname());

     path_window(colors);
     len = strlen(curgame->getdir());
     if (len < DIRLENGTH)
       cprintf("%s", curgame->getdir());
     else
     {
       for (curchar = 0; curchar < DIRLENGTH - 4; curchar ++)
         cprintf("%c", curgame->getdir()[curchar]);
       cprintf("...");
     }

     exec_window(colors);
     len = strlen(curgame->getexec());
     if (len < EXECLENGTH)
       cprintf("%s", curgame->getexec());
     else
     {
       for (curchar = 0; curchar < EXECLENGTH - 4; curchar ++)
         cprintf("%c", curgame->getexec()[curchar]);
       cprintf("...");
     }

     opt_window(colors);
     len = strlen(curgame->getopts());
     if (len < OPTIONLENGTH)
       cprintf("%s", curgame->getopts());
     else
     {
       for (curchar = 0; curchar < OPTIONLENGTH - 4; curchar ++)
         cprintf("%c", curgame->getopts()[curchar]);
       cprintf("...");
     }
   }
}

//**************************************************************************
//  Gets a numerical value for the key pushed, including shift and control
//    characters
//**************************************************************************
// swiped from Borland Tcalc example

int getkey(void)
/* Uses the BIOS to read the next keyboard character */
{
 int key, lo, hi;

 key = bioskey(0);
 lo = key & 0X00FF;
 hi = (key & 0XFF00) >> 8;
 return((lo == 0) ? hi + 256 : lo);
}

// end swipe


//**************************************************************************
//  Set up the batch file to run the current selection
//**************************************************************************

void rungame2(gamelist2 &games)
{
   FILE *batfile;            //  Batch file used to tun games
   FILE *dirfile;            //  File containg location of the menu program
   char curdir[LFNLENGTH+1]; //  Directory as read in from that file
   int eye;                  //  Loop variable
   game2* curgame;

   textcolor(WHITE);
   textbackground(RED);
   window(1,1,80,25);
   clrscr();

   dirfile = fopen("basedir.jmq", "rb");
   eye = 0;
   while (!feof(dirfile))
   {
     curdir[eye] = fgetc(dirfile);
     eye = eye + 1;
   }

   curgame = games.Current();
   batfile = fopen("callme.bat", "wt");
   fprintf(batfile, "%c%c\n", curgame->getdir()[0], curgame->getdir()[1]);
   fprintf(batfile, "cd %s\n", curgame->getdir());
   fprintf(batfile, "call %s %s\n", curgame->getexec(), curgame->getopts());

   fprintf(batfile, "%c%c\n", curdir[0], curdir[1]);
   fprintf(batfile, "cd ");
   eye = 0;
   while (curdir[eye+1] != '\n')
   {
     fprintf(batfile, "%c", curdir[eye]);
     eye = eye + 1;
   }
   fprintf(batfile, "\n");
   fprintf(batfile, "pause\n");

   fclose(batfile);
}

//**************************************************************************
//  Draws the submenu for editing, running, or adding a game
//**************************************************************************

void submenuwin(void)
{

  window(16, 10, 65, 14);
  textcolor(WHITE);
  textbackground(MAGENTA);
  clrscr();

  window(19, 11, 62, 13);
  cprintf("Press a happy button, man.");

  window(21, 13, 26, 13);
  textbackground(BLUE);
  cprintf(" RUN ");

  window(30, 13, 36, 13);
  textbackground(BLUE);
  cprintf(" EDIT ");

  window(40, 13, 48, 13);
  textbackground(BLUE);
  cprintf(" CANCEL ");

  window(52, 13, 61, 13);
  textbackground(BLUE);
  cprintf(" ADD NEW ");
}


//**************************************************************************
//  Highlights the current selection in the add/edit/run submenu
//**************************************************************************

void lightbutton(int &choice)
{
  switch (choice)
  {
    case 0:  window(21, 13, 26, 13);
             textbackground(CYAN);
             cprintf(" RUN ");
             break;

    case 1:  window(30, 13, 36, 13);
             textbackground(CYAN);
             cprintf(" EDIT ");
             break;

    case 2:  window(40, 13, 48, 13);
             textbackground(CYAN);
             cprintf(" CANCEL ");
             break;

    case 3:  window(52, 13, 61, 13);
             textbackground(CYAN);
             cprintf(" ADD NEW ");
             break;
  }
}


//**************************************************************************
//  Removes a game from the list
//  I'll let me know if and when I can figure out exactly what I did here
//    to make it behave right.  Maybe I need a printout...
//**************************************************************************

void removegame2(gamelist2 &games, int &monkey, barpos &menupos, int numgames)
{

  if (games.Next() == NULL)  // no next game
  {
    if (monkey > SELMENUTOP) // highlight not at top
    {
      if ( (numgames - 1) <= (SELMENUBOT - SELMENUTOP + 1) )  // less games
      {                                                   // than list length
        monkey -= 1;
        menupos.bottom -= 1;
        menupos.dist -= 1;
      }
      else    // more games
      {
        menupos.bottom -= 1;
        menupos.dist -= 1;
        menupos.top -= 1;
      }
    }
    else  // highlight at top
    {
      if ( (numgames - 1) < (SELMENUBOT - SELMENUTOP + 1) )  // less games
      {                                                   // than list length
        if (menupos.bottom > 0)
          menupos.bottom -= 1;
      }
      else    // more games
      {
        menupos.bottom -= 1;
        menupos.dist -= 1;
        menupos.top -= 1;
      }
    }
    games.Remove();
  }
  else if (games.Previous())  // there is a next game
  {
    if ( (numgames - 2) < (SELMENUBOT - SELMENUTOP + 1) ) // less games than
    {                                                     // list length
      menupos.bottom -= 1;
    }
    else if ((menupos.bottom >= numgames - 1 ) && (menupos.top > 0))
    {
      menupos.top -= 1;
      monkey += 1;
      menupos.bottom -= 1;
    }
    games.Remove();
  }
  else
  {
    games.Remove();
    if (menupos.bottom > 0)
      menupos.bottom -= 1;
  }

/*  if (games.Next() == NULL)
  {
    if(monkey > SELMENUTOP)
    {
      monkey -=1;
      menupos.bottom -= 1;
      menupos.dist -= 1;
    }
    else if (monkey == SELMENUTOP)
    {
      menupos.top -= 1;
      menupos.dist -= 1;
    }
    games.Remove();
  }
  else if (games.Previous())
  {
    games.Remove();
  }

  if ((menupos.bottom - menupos.top) >= ((numgames - 1) - menupos.top))
  {
    menupos.top -= 1;
    if (numgames - 1 > SELMENUBOT - SELMENUTOP + 1)
      monkey += 1;
  }

  // This is to fix problems I cause above
  if (menupos.top < 0)
  {
    menupos.top = 0;
    menupos.bottom -= 1;
  }
*/
}

//**************************************************************************
//  Copy a game entry
//**************************************************************************

void copygame2(gamelist2 &glist, barpos &menupos)
{
//   games.Ptr = new List;       //  Set up a node to store data in
//   if (games.Head != NULL)
//   {
//      games.Ptr->Prev = games.Cur;
//      games.Ptr->Data = games.Cur->Data;
//      games.Ptr->Next = games.Cur->Next;
//      if (games.Ptr->Next != NULL)
//        games.Ptr->Next->Prev = games.Ptr;
//      games.Cur->Next = games.Ptr;   //  Insert the node at the end of the list
//   }

   game2 *curgame;

   curgame = glist.Current();
   glist.Insert(new game2(curgame->getname(), curgame->getdir(),
                          curgame->getexec(), curgame->getopts() ));
   if (menupos.bottom < SELMENUBOT - SELMENUTOP + 1)
     menupos.bottom += 1;


}

//**************************************************************************
//  Sets up window for text to add or edit a game
//**************************************************************************

void add_window(void)
{
   textbackground(CYAN);
   window(8, PWINPOS - 5 , 72, PWINPOS - 2);
   clrscr();
   textcolor(WHITE);
   window(10, PWINPOS - 4 , 70, PWINPOS - 3);
   clrscr();
}


//**************************************************************************
//  Add a game to the list, getting information from the user
//**************************************************************************

void insertgame2(gamelist2 &games, int &monkey, colorset &colors)
{
   int len, curchar;
   char newname[NAMELENGTH+1];     //  New game name
   char newdir[LFNLENGTH+1];       //  New game directory
   char newexec[LFNLENGTH+1];      //  New game executable name
   char newopts[LFNLENGTH+1];      //  New game options
   int i;                          //  Loop again
   char firstname[NAMELENGTH + 1], secondname[NAMELENGTH +1 ];
                                   //  Names to compare for sorting
   gamepiece parttype;             //  Portion of game data being entered

//   games.Ptr = new List;       //  Set up a node to store data in
//   if (games.Head != NULL)
//   {
//      games.Ptr->Prev = games.Cur;
//      games.Ptr->Next = games.Cur->Next;
//      if (games.Ptr->Next != NULL)
//        games.Ptr->Next->Prev = games.Ptr;
//      games.Cur->Next = games.Ptr;   //  Insert the node at the end of the list
//   }

   path_window(colors);
   clrscr();
   exec_window(colors);
   clrscr();
   opt_window(colors);
   clrscr();

   add_window();
   cprintf("Enter the new game description (%d characters max): \n\r",
             NAMELENGTH - 1);
   parttype = NAME;
   textcolor(YELLOW);
   getitem(newname, parttype, 0);
   textcolor(WHITE);

   add_window();
   cprintf("Enter the directory for this game (%d chars max): \n\r",
              LFNLENGTH-1);
   path_window(colors);
   parttype = DIRNAME;
   textcolor(YELLOW);
   getitem(newdir, parttype, 0);
   textcolor(colors.winfg);
   clrscr();
   len = strlen(newdir);
   if (len < DIRLENGTH)
     cprintf("%s", newdir);
   else
   {
     for (curchar = 0; curchar < DIRLENGTH - 4; curchar ++)
       cprintf("%c", newdir[curchar]);
     cprintf("...");
   }

   add_window();
   cprintf("Enter the name of the file to run (%d chars max): \n\r",
              LFNLENGTH-1);
   exec_window(colors);
   parttype = EXECNAME;
   textcolor(YELLOW);
   getitem(newexec, parttype, 0);
   textcolor(colors.winfg);
   clrscr();
   len = strlen(newexec);
   if (len < EXECLENGTH)
     cprintf("%s", newexec);
   else
   {
     for (curchar = 0; curchar < EXECLENGTH - 4; curchar ++)
       cprintf("%c", newexec[curchar]);
     cprintf("...");
   }

   add_window();
   cprintf("Enter any options to run it with (%d chars max): \n\r",
              LFNLENGTH-1);
   opt_window(colors);
   parttype = EXECOPTS;
   textcolor(YELLOW);
   getitem(newopts, parttype, 0);
   textcolor(colors.winfg);
   clrscr();
   len = strlen(newopts);
   if (len < OPTIONLENGTH)
     cprintf("%s", newopts);
   else
   {
     for (curchar = 0; curchar < OPTIONLENGTH - 4; curchar ++)
       cprintf("%c", newopts[curchar]);
     cprintf("...");
   }

   games.Insert(new game2(newname, newdir, newexec, newopts));
/*   i = 0;
   while (i < NAMELENGTH)
   {
     games.Ptr->Data.name[i] = newname[i];
     i = i + 1;
   }
   i = 0;
   while (i < LFNLENGTH)
   {
     games.Ptr->Data.directory[i] = newdir[i];
     i = i + 1;
   }
   i = 0;
   while (i < LFNLENGTH)
   {
     games.Ptr->Data.exec_name[i] = newexec[i];
     i = i + 1;
   }
   i = 0;
   while (i < LFNLENGTH)
   {
     games.Ptr->Data.exec_options[i] = newopts[i];
     i = i + 1;
   }

   if (games.Head != NULL)
   {
     strcpy(firstname, games.Ptr->Data.name);
     strcpy(secondname, games.Cur->Data.name);
     for (i=0; i < NAMELENGTH; i++)
     {
       firstname[i] = toupper(firstname[i]);
       secondname[i] = toupper(secondname[i]);
     }

     games.Cur = games.Ptr;

     if (strcmp(firstname,secondname) > 0)
     {
       games.Cur = games.Cur->Prev;
     }
     else if (monkey == SELMENULEN)
     {
       games.topPtr = games.topPtr->Next;
     }
     else if (monkey < SELMENULEN)
       monkey = monkey + 1;
   }
   else
   {
     games.Cur = games.Ptr;
     games.Cur->Next = NULL;
     games.Cur->Prev = NULL;
     games.Head = games.Cur;
     games.topPtr = games.Cur;
     games.botPtr = games.Cur;
   }
*/
}

//**************************************************************************
//  Allows editing of and reads in the current segment of game data being
//    modified
//**************************************************************************

void getitem(char *newitem, gamepiece &pick, int edit)
{
   int maxlen;        //  Maximum allowable length for the current text field
   int pos, len;      //  Position within and length of current item being
                      //    modified
   int readinchar;    //  Character read in
   int i;             //  I'm going loopy!
   int line;          //  Line current game resides on
   int maxpos;
   int strpos;
   int curchar;

   switch (pick)
   {
     case NAME:
       maxlen = NAMELENGTH-1;
       maxpos = maxlen;
       line = 2;
       break;
     case DIRNAME:
       maxlen = LFNLENGTH-1;
       maxpos = DIRLENGTH-1;
       line = 1;
       break;
     case EXECNAME:
       maxlen = LFNLENGTH-1;
       maxpos = EXECLENGTH-1;
       line = 1;
       break;
     case EXECOPTS:
       maxlen = LFNLENGTH-1;
       maxpos = OPTIONLENGTH-1;
       line = 1;
       break;
   }

   pos = 0;
   len = 0;
   strpos = 0;

   if (edit)
   {
     gotoxy(1, line);
     clreol();
     len = strlen(newitem);
     if (len < maxpos)
     {
       cprintf("%s", newitem);
       strpos = len;
       pos = len;
     }
     else
     {
       for (strpos = 0; strpos < maxpos; strpos++)
         cprintf("%c", newitem[strpos]);
       pos = strpos;
     }
     if (pos > maxpos)
       pos = maxpos;
     gotoxy(pos+1, line);
   }

   newitem[len] = NULL;

   while ( (readinchar = getkey()) != CR)
   {
     switch (readinchar)
     {
       case LEFTKEY:
       case UPKEY:
         if (pos > 0)
         {
           strpos = strpos - 1;
           pos = pos - 1;
         }
         else if (strpos > 0)
           strpos = strpos - 1;
         break;
       case RIGHTKEY:
       case DOWNKEY:
         if ((pos < maxpos) && (strpos < len))
         {
           pos = pos + 1;
           strpos = strpos + 1;
         }
         else if ((pos == maxpos) && (strpos < len))
           strpos = strpos + 1;
         break;
       case HOMEKEY:
         pos = 0;
         strpos = 0;
         break;
       case ENDKEY:
         if (len <= maxpos)
         {
           pos = len;
           strpos = pos;
         }
         else
         {
           pos = maxpos;
           strpos = len;
         }
         break;
       case DELKEY:
         if ((len > 0) && (strpos < len))
         {
           for (i = strpos; i < len+1; i++)
             newitem[i] = newitem[i + 1];
           len = len - 1;
         }
         break;
       case BS:
         if (len > 0)
         {
          for (i = strpos - 1; i < len+1; i++)
            newitem[i] = newitem[i + 1];
          len = len - 1;
          if (pos > 0)
            pos = pos - 1;
          strpos = strpos - 1;
         }
         break;
       default:
         if ((len < maxlen) && ( isprint(readinchar)))
         {
           for (i = len; i > strpos; i--)
             newitem[i] = newitem[i - 1];
           newitem[strpos] = readinchar;
           if (pos < maxpos)
             pos = pos + 1;
           strpos = strpos + 1;
           len = len + 1;
           newitem[len] = NULL;
         }
         break;
     }
     gotoxy(1, line);
     clreol();
     if (pos == maxpos)
     {
       for (curchar = strpos - maxpos; curchar < strpos; curchar++)
         if (curchar < len)
           cprintf("%c", newitem[curchar]);
     }
     else if (pos == 0)
     {
       for (curchar = strpos; curchar < strpos + maxpos; curchar++)
         if (curchar < len)
           cprintf("%c", newitem[curchar]);
     }
     else
     {
       for (curchar = strpos - pos; curchar < maxpos+(strpos-pos); curchar++)
         if (curchar < len)
           cprintf("%c", newitem[curchar]);
     }
     gotoxy(pos+1, line);
   }
}

//**************************************************************************
//  Sets up the windows for editing a game's current information
//**************************************************************************

void editgame2(gamelist2 &glist, colorset &colors)
{
   int i;
   char firstname[NAMELENGTH + 1], secondname[NAMELENGTH +1 ];
   gamepiece parttype;
   int len, curchar;
   char edname[NAMELENGTH+1];     //  New game name
   char eddir[LFNLENGTH+1];       //  New game directory
   char edexec[LFNLENGTH+1];      //  New game executable name
   char edopts[LFNLENGTH+1];      //  New game options
//   game2 *curgame;

//   curgame = glist.Current();
//   strcpy(edname, curgame->getname());
//   strcpy(eddir, curgame->getdir());
//   strcpy(edexec, curgame->getexec());
//   strcpy(edopts, curgame->getopts());
   strcpy(edname, glist.Current()->getname());
   strcpy(eddir, glist.Current()->getdir());
   strcpy(edexec, glist.Current()->getexec());
   strcpy(edopts, glist.Current()->getopts());

   add_window();
   cprintf("Edit the game description.  Enter when done.  %d chars.\n\r",
             NAMELENGTH - 1);
   parttype = NAME;
   textcolor(YELLOW);
   getitem(edname, parttype, 1);
   textcolor(WHITE);

   add_window();
   cprintf("Edit the directory for this game (%d chars max): \n\r",
              LFNLENGTH-1);
   path_window(colors);
   parttype = DIRNAME;
   textcolor(YELLOW);
   getitem(eddir, parttype, 1);
   textcolor(colors.winfg);
   clrscr();
   len = strlen(eddir);
   if (len < DIRLENGTH)
     cprintf("%s", eddir);
   else
   {
     for (curchar = 0; curchar < DIRLENGTH - 4; curchar ++)
       cprintf("%c", eddir[curchar]);
     cprintf("...");
   }

   add_window();
   cprintf("Edit the name of the file to run (%d chars max): \n\r",
              LFNLENGTH-1);
   exec_window(colors);
   parttype = EXECNAME;
   textcolor(YELLOW);
   getitem(edexec, parttype, 1);
   textcolor(colors.winfg);
   clrscr();
   len = strlen(edexec);
   if (len < EXECLENGTH)
     cprintf("%s", edexec);
   else
   {
     for (curchar = 0; curchar < EXECLENGTH - 4; curchar ++)
       cprintf("%c", edexec[curchar]);
     cprintf("...");
   }

   add_window();
   cprintf("Edit the options to run it with (%d chars max): \n\r",
              LFNLENGTH-1);
   opt_window(colors);
   parttype = EXECOPTS;
   textcolor(YELLOW);
   getitem(edopts, parttype, 1);
   textcolor(colors.winfg);
   clrscr();
   len = strlen(edopts);
   if (len < OPTIONLENGTH)
     cprintf("%s", edopts);
   else
   {
     for (curchar = 0; curchar < OPTIONLENGTH - 4; curchar ++)
       cprintf("%c", edopts[curchar]);
     cprintf("...");
   }
   glist.Insert(new game2(edname, eddir, edexec, edopts));
   glist.Previous();
   glist.Remove();
}

//**************************************************************************
//  Searches the list, starting with the next position, to find the next game
//    with the character pressed as the first character of it's game
//    description
//**************************************************************************

int finditem2(gamelist2 &games, int &character, int &monkey, barpos &menupos,
              int &numgames)
{
   int hank;
   int checkedall;
   int found;
   int numshifted;
   int i;
   int dist;
   char name[LFNLENGTH + 1];
   char name2[LFNLENGTH + 1];
   char name3[LFNLENGTH + 1];
   game2 *checkgame, *curgame;

   found = 0;
   checkedall = 0;
   numshifted = 0;
   dist = 0;

   curgame = games.Current();
   strcpy(name, curgame->getname());
   if (games.Next() != NULL)
   {
     dist = 1;
     menupos.dist += 1;
   }
   else
   {
     while (games.Previous() != NULL)
     {
       dist = dist - 1;
       menupos.dist -= 1;
     }
   }

   while ((!checkedall) && (!found))
   {
     checkgame = games.Current();
     strcpy(name3, checkgame->getname());
     if ( toupper((int)checkgame->getname()[0]) == toupper(character))
     {
       found = 1;
       hank = monkey + dist;

       if (hank < SELMENUTOP)
         hank = SELMENUTOP;
       else if (hank > SELMENUBOT+1)
         hank = SELMENUBOT+1;

       if (dist < SELMENUTOP - monkey)
         numshifted = dist - (SELMENUTOP - monkey);
       else if (dist > SELMENUBOT - monkey + 1)
         numshifted = dist - (SELMENUBOT - monkey + 1);

       if (numshifted > 0)
       {
         for (i = 0; i < numshifted; i++)
         {
           if (menupos.bottom < numgames - 1)
           {
             menupos.top += 1;
             menupos.bottom += 1;
           }
         }
       }
       else
       if (numshifted < 0)
       {
         for (i = 0; i > numshifted; i--)
         {
           if (menupos.top != 0)
           {
             menupos.top -= 1;
             menupos.bottom -= 1;
           }
         }
       }
       monkey = hank;
     }
     else
     if (games.Next() == NULL)
     {
       while (games.Previous() != NULL)
       {
         dist = dist - 1;
         menupos.dist -= 1;
       }
     }
     else
     {
       dist = dist + 1;
       menupos.dist += 1;
     }

     if (games.Current() == curgame)
       checkedall = 1;
   }
   return(found);
}

void parseargs(char *arglist[], colorset &colors, int &numargs)
{
   int loop;
   int item;                  //  Item color is set for
   int changecol = 0;         //  Change a color or don't
   int changeone;             //  If a valid color, change it
   COLORS newcol;             //  Color value set from cfg file

   for (loop=1; loop <= numargs; loop++)
     {
     if ((arglist[loop][0] == '/') || (arglist[loop][0] == '-'))
       {
         if ( (strncmp(arglist[loop], "/mainbg", strlen("/mainbg")) == 0) ||
              (strncmp(arglist[loop], "-mainbg", strlen("-mainbg")) == 0) )
         {
           item = 1;
           changecol = 1;
           changeone = 1;
         }
         else
         if ( (strncmp(arglist[loop], "/mainfg", strlen("/mainfg")) == 0) ||
              (strncmp(arglist[loop], "-mainfg", strlen("-mainfg")) == 0) )
         {
           item = 2;
           changecol = 1;
           changeone = 1;
         }
         if ( (strncmp(arglist[loop], "/namebg", strlen("/namebg")) == 0) ||
              (strncmp(arglist[loop], "-namebg", strlen("-namebg")) == 0) )
         {
           item = 3;
           changecol = 1;
           changeone = 1;
         }
         else
         if ( (strncmp(arglist[loop], "/namefg", strlen("/namefg")) == 0) ||
              (strncmp(arglist[loop], "-namefg", strlen("-namefg")) == 0) )
         {
           item = 4;
           changecol = 1;
           changeone = 1;
         }
         if ( (strncmp(arglist[loop], "/winbg", strlen("/winbg")) == 0) ||
              (strncmp(arglist[loop], "-winbg", strlen("-winbg")) == 0) )
         {
           item = 5;
           changecol = 1;
           changeone = 1;
         }
         else
         if ( (strncmp(arglist[loop], "/winfg", strlen("/winfg")) == 0) ||
              (strncmp(arglist[loop], "-winfg", strlen("-winfg")) == 0) )
         {
           item = 6;
           changecol = 1;
           changeone = 1;
         }
         else
         if ( (strncmp(arglist[loop], "/barbg", strlen("/barbg")) == 0) ||
              (strncmp(arglist[loop], "-barbg", strlen("-barbg")) == 0) )
         {
           item = 7;
           changecol = 1;
           changeone = 1;
         }
         else
         if ( (strncmp(arglist[loop], "/barfg", strlen("/barfg")) == 0) ||
              (strncmp(arglist[loop], "-barfg", strlen("-barfg")) == 0) )
         {
           item = 8;
           changecol = 1;
           changeone = 1;
         }
         else
         if ( (strncmp(arglist[loop], "/resetcols", strlen("/resetcols")) == 0) ||
              (strncmp(arglist[loop], "-resetcols", strlen("-resetcols")) == 0) )
         {
           colors.mainbg = BLUE;
           colors.mainfg = WHITE;
           colors.namebg = BLACK;
           colors.namefg = LIGHTGREEN;
           colors.winbg = BLACK;
           colors.winfg = WHITE;
           colors.barbg = RED;
           colors.barfg = WHITE;
         }
         else
         if ( (strncmp(arglist[loop], "/help", strlen("/help")) == 0) ||
              (strncmp(arglist[loop], "-help", strlen("-help")) == 0) ||
              (strncmp(arglist[loop], "/h", strlen("/h")) == 0) ||
              (strncmp(arglist[loop], "-h", strlen("-h")) == 0) ||
              (strncmp(arglist[loop], "/?", strlen("/?")) == 0) ||
              (strncmp(arglist[loop], "-?", strlen("-?")) == 0) )
         {
           printf("The Master Cow's Game Menu v%s                           %s %s\n\n\r"
                    ,VERSION, DATE, TIME);
           printf("usage: runme [-options]\n\r");
           printf("  options are as follows:\n\r");
           printf("  -mainbg colorname           where colorname is one of the following:\n\r");
           printf("  -mainfg colorname               black           grey\n\r");
           printf("  -namebg colorname               blue            lblue\n\r");
           printf("  -namefg colorname               green           lgreen\n\r");
           printf("  -winbg colorname                cyan            lcyan\n\r");
           printf("  -winfg colorname                red             lred\n\r");
           printf("  -barbg colorname                magenta         lmagenta\n\r");
           printf("  -barfg colorname                brown           yellow\n\r");
           printf("                                  lgrey           white\n\r");
           printf("  -resetcols\n\r");
           printf("  -cs #                       where # is a number from 1 to 5\n\r");
           printf("  -help, -h, or -?\n\n\r");
           printf("You may use \"/\" in place of \"-\".\n\n\r");
           printf("See readme.txt for more information.\n\n\r");

           remove("basedir.jmq");
           remove("callme.bat");

           _setcursortype(_NORMALCURSOR);
           exit(1);
         }
         else
         if ( (strncmp(arglist[loop], "/cs", strlen("/cs")) == 0) ||
              (strncmp(arglist[loop], "-cs", strlen("-cs")) == 0) )
         {
           if (strncmp(arglist[loop + 1], "1", strlen("1")) == 0)
           {
             colors.mainbg = BLUE;
             colors.mainfg = WHITE;
             colors.namebg = BLACK;
             colors.namefg = LIGHTGREEN;
             colors.winbg = BLACK;
             colors.winfg = WHITE;
             colors.barbg = RED;
             colors.barfg = WHITE;
           }
           else
           if (strncmp(arglist[loop + 1], "2", strlen("2")) == 0)
           {
             colors.mainbg = RED;
             colors.mainfg = WHITE;
             colors.namebg = BLACK;
             colors.namefg = LIGHTGRAY;
             colors.winbg = BLACK;
             colors.winfg = WHITE;
             colors.barbg = MAGENTA;
             colors.barfg = WHITE;
           }
           else
           if (strncmp(arglist[loop + 1], "3", strlen("3")) == 0)
           {
             colors.mainbg = BLACK;
             colors.mainfg = LIGHTGRAY;
             colors.namebg = BLACK;
             colors.namefg = LIGHTGRAY;
             colors.winbg = BLACK;
             colors.winfg = LIGHTGRAY;
             colors.barbg = BLACK;
             colors.barfg = WHITE;
           }
           else
           if (strncmp(arglist[loop + 1], "4", strlen("4")) == 0)
           {
             colors.mainbg = BLACK;
             colors.mainfg = LIGHTGREEN;
             colors.namebg = BLACK;
             colors.namefg = LIGHTGREEN;
             colors.winbg = BLACK;
             colors.winfg = LIGHTGREEN;
             colors.barbg = GREEN;
             colors.barfg = BLACK;
           }
           else
           if (strncmp(arglist[loop + 1], "5", strlen("5")) == 0)
           {
             colors.mainbg = BROWN;
             colors.mainfg = YELLOW;
             colors.namebg = BLACK;
             colors.namefg = CYAN;
             colors.winbg = BLACK;
             colors.winfg = YELLOW;
             colors.barbg = BLACK;
             colors.barfg = YELLOW;
           }
         }

         if (changecol)
         {
           if (strncmp(arglist[loop + 1], "black", strlen("black")) == 0)
             newcol = BLACK;
           else
           if (strncmp(arglist[loop + 1], "blue", strlen("blue")) == 0)
             newcol = BLUE;
           else
           if (strncmp(arglist[loop + 1], "green", strlen("green")) == 0)
             newcol = GREEN;
           else
           if (strncmp(arglist[loop + 1], "cyan", strlen("cyan")) == 0)
             newcol = CYAN;
           else
           if (strncmp(arglist[loop + 1], "red", strlen("red")) == 0)
             newcol = RED;
           else
           if (strncmp(arglist[loop + 1], "magenta", strlen("magenta")) == 0)
             newcol = MAGENTA;
           else
           if (strncmp(arglist[loop + 1], "brown", strlen("brown")) == 0)
             newcol = BROWN;
           else
           if (strncmp(arglist[loop + 1], "lgrey", strlen("lgrey")) == 0)
             newcol = LIGHTGRAY;
           else
           if (strncmp(arglist[loop + 1], "grey", strlen("grey")) == 0)
             newcol = DARKGRAY;
           else
           if (strncmp(arglist[loop + 1], "lblue", strlen("lblue")) == 0)
             newcol = LIGHTBLUE;
           else
           if (strncmp(arglist[loop + 1], "lgreen", strlen("lgreen")) == 0)
             newcol = LIGHTGREEN;
           else
           if (strncmp(arglist[loop + 1], "lcyan", strlen("lcyan")) == 0)
             newcol = LIGHTCYAN;
           else
           if (strncmp(arglist[loop + 1], "lred", strlen("lred")) == 0)
             newcol = LIGHTRED;
           else
           if (strncmp(arglist[loop + 1], "lmagenta", strlen("lmagenta")) == 0)
             newcol = LIGHTMAGENTA;
           else
           if (strncmp(arglist[loop + 1], "yellow", strlen("yellow")) == 0)
             newcol = YELLOW;
           else
           if (strncmp(arglist[loop + 1], "white", strlen("white")) == 0)
             newcol = WHITE;
           else
             changeone = 0;
           changecol = 0;

           if (changeone)
           {
             switch (item)
             {
               case 1:  colors.mainbg = newcol;
                 break;
               case 2:  colors.mainfg = newcol;
                 break;
               case 3:  colors.namebg = newcol;
                 break;
               case 4:  colors.namefg = newcol;
                 break;
               case 5:  colors.winbg = newcol;
                 break;
               case 6:  colors.winfg = newcol;
                 break;
               case 7:  colors.barbg = newcol;
                 break;
               case 8:  colors.barfg = newcol;
                 break;
             }
             changeone = 0;
           }
         }
       }
     }

}


//**************************************************************************
//  Sets up a confirm window for deleting a game from the list
//**************************************************************************

void deletewin(char *name)
{
  int width, namelength, i;

  window(16, 10, 65, 15);
  textcolor(LIGHTRED);
  textbackground(LIGHTGRAY);
  clrscr();

  window(19, 11, 62, 14);
  cprintf("WARNING!!!");
  textcolor(WHITE);
  cprintf("  Are you SURE you want to delete\n\r");
  namelength = strlen(name) - 1;
  width = (62 - 19)/2 - (namelength/2) - 3;
  for (i = 0; i < width; i++)
    cprintf(" ");
  cprintf("\"");
  textcolor(RED);
  cprintf("%s",name);
  textcolor(WHITE);
  cprintf("\" ?");
  window(25, 14, 34, 14);
  cprintf(" AYUP... ");

  window(44, 14, 56, 14);
  cprintf(" Oops!  NO! ");
}


//**************************************************************************
//  Highlights the current selection when in the delete submenu
//**************************************************************************

void lightdelbutton(int &choice)
{
  switch (choice)
  {
    case 0:  window(25, 14, 34, 14);
             textbackground(RED);
             cprintf(" AYUP... ");
             break;

    case 1:  window(44, 14, 56, 14);
             textbackground(RED);
             cprintf(" Oops!  NO! ");
             break;
  }
}

//**************************************************************************
//  Writes the config file
//**************************************************************************

void writecfg2(gamelist2 &glist, FILE &outfile)
{
  int i;                //  Loop variable

  putc(145, &outfile);  //   is alt-145   is alt-146
  i =  0;
  while (glist.Current()->getname()[i] != NULL)
  {
    putc(glist.Current()->getname()[i], &outfile);
    i = i + 1;
  }
  fprintf(&outfile, "\n");
  i =  0;
  while (glist.Current()->getdir()[i] != NULL)
  {
    putc(glist.Current()->getdir()[i], &outfile);
    i = i + 1;
  }
  fprintf(&outfile, "\n");
  i =  0;
  while (glist.Current()->getexec()[i] != NULL)
  {
    putc(glist.Current()->getexec()[i], &outfile);
    i = i + 1;
  }
  i =  0;
  fprintf(&outfile, "\n");
  while (glist.Current()->getopts()[i] != NULL)
  {
    putc(glist.Current()->getopts()[i], &outfile);
    i = i + 1;
  }
  putc(146, &outfile);
  fprintf(&outfile, "\n");
}

//**************************************************************************
//  Essentially clears the screen when quitting, with final message
//**************************************************************************

void quit_window(void)
{
   int bobby;       //  Random number used to decide which message to print

   textbackground(BLACK);
   textcolor(LIGHTGRAY);
   window(1,1,80,25);
   clrscr();
   randomize();
   bobby = rand()%10;
   switch (bobby)
   {
     case 0: cprintf("%s", MESSAGE1);
             break;
     case 1: cprintf("%s", MESSAGE2);
             break;
     case 2: cprintf("%s", MESSAGE3);
             break;
     case 3: cprintf("%s", MESSAGE4);
             break;
     case 4: cprintf("%s", MESSAGE5);
             break;
     case 5: cprintf("%s", MESSAGE6);
             break;
     case 6: cprintf("%s", MESSAGE7);
             break;
     case 7: cprintf("%s", MESSAGE8);
             break;
     case 8: cprintf("%s", MESSAGE9);
             break;
     case 9: textcolor(RED);
             cprintf("Bloody finger... BLOODY FINGER!!!!");
             textcolor(LIGHTGRAY);
             break;
   }
   cprintf("\n\r");
}


//**************************************************************************
//  Redraws the screen, saving on naught but main .cpp function length
//**************************************************************************

void refresh (colorset &colors, gamelist2 &games, barpos &menupos,
               int &monkey)
{
   int i;

   big_window(colors);
   path_window(colors);
   clrscr();
   exec_window(colors);
   clrscr();
   opt_window(colors);
   clrscr();
   name_window(colors);
   clrscr();
   if (!games.Empty())
   {
     games.First();
     for (i = 0; i < menupos.top; i++)
       games.Next();
     traverse(games, menupos, 1);
     highlight3(monkey, games, colors);
   }
}

