//  The Master Cow's Game Menu
//  by Jason Quattrini
//  v0.99k2
//  01/10/01
//
//  This is not the main .C file.
//
//  This program is a menu, intended for running games, for an MS-DOS based
//    computer.  It can be used with almost any DOS-based program if you
//    so desire.
#include "gameme_u.h"

void List2::Insert(node *p)
{
  if (Head == NULL)
  {
    Cur = p;
    Cur->Next = NULL;
    Cur->Prev = NULL;
    Head = Cur;
  }
  else if (Cur->Next != NULL)
  {
    p->Next = Cur->Next;
//    Cur->Next->Prev = p;
    Cur->Next = p;
    p->Prev = Cur;
    p->Next->Prev = p;
    Cur = p;
  }
  else
  {
    p->Next = NULL;
    Cur->Next = p;
    p->Prev = Cur;
    Cur = p;
  }
}


node* List2::Remove()
{
  node *p;

  if (Cur == NULL)
    return 0;
  if (Cur->Prev == NULL)
  {
    Head = Cur->Next;
    if (Cur->Next != NULL)
      Cur->Next->Prev = NULL;
  }
  else
  {
    Cur->Prev->Next = Cur->Next;
    if (Cur->Next != NULL)
      Cur->Next->Prev = Cur->Prev;
  }
  p = Cur;
  Cur = Cur->Next;
  delete p;
//  return p;
}

node* List2::Next()
{
  if (Cur->Next == NULL)
    return 0;
//  Cur->Prev = Cur;
  Cur = Cur->Next;
  return Cur;
}

node* List2::Previous()
{
  if (Cur->Prev == NULL)
    return 0;
//  Cur->Next = Cur;
  Cur = Cur->Prev;
  return Cur;
}

class game2 : private node
{
  char game_name[NAMELENGTH + 1],       //  The name of the game
       game_dir[LFNLENGTH + 1],       //  The directory in which it resides
                                       //    (path to the game)
       exec_name[LFNLENGTH + 1],       //  What to run to make the game go
       exec_options[LFNLENGTH +1];     //  Any options to feed to the game
                                       //    when run
  public:
    game2(char *, char *, char *, char *);
    char* getname()
    {
      return game_name;
    }
    char* getdir()
    {
      return game_dir;
    }
    char* getexec()
    {
      return exec_name;
    }
    char* getopts()
    {
      return exec_options;
    }
};

game2::game2(char g_name[NAMELENGTH + 1], char g_dir[LFNLENGTH + 1],
             char ex_name[LFNLENGTH + 1], char ex_opts[LFNLENGTH + 1])
{
  int i;

  for (i = 0; i < NAMELENGTH; i++)
    game_name[i] = g_name[i];
  for (i = 0; i < LFNLENGTH; i++)
  {
    game_dir[i] = g_dir[i];
    exec_name[i] = ex_name[i];
    exec_options[i] = ex_opts[i];
  }
}


class gamelist2:public List2
{
  friend class barpos;
  public:
    gamelist2() {}
    void Insert(game2* p)
    {
      List2::Insert( (node*)p );
    }
    game2* Remove()
    {
      return (game2*)List2::Remove();
    }
    game2* First()
    {
      return (game2*)List2::First();
    }
    game2* Next()
    {
      return (game2*)List2::Next();
    }
    game2* Current()
    {
      return (game2*)List2::Current();
    }
    game2* Previous()
    {
      return (game2*)List2::Previous();
    }
    Boolean Empty()
    {
      return List2::Empty();
    }
};

class barpos
{
  public:
    barpos() {};
    int top;
//    int current;
    int bottom;
    int dist;       // distance of highlighted item from the head of the list
};
